import { BaseEvent } from '#application/base/baseEvent'
import { CharacterHair } from '#entities/characterHair'
import characterHairRepository from '#repositories/characterHairRepository'

interface IPayload {}

export default class characterHairListEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:characterHair:list', this.handleEvent.bind(this))
  }

  private async handleEvent(data: IPayload, callback: (response: CharacterHair[]) => void): Promise<void> {
    try {
      if (!(await this.isCharacterGM())) return

      const items = await characterHairRepository.getAll()
      return callback(items)
    } catch (error) {
      this.logger.error('gm:characterHair:list error', error)
      return callback([])
    }
  }
}
